function Variables = in(DynareModel, constraints, variables, id)

if ~iscell(constraints)
    error('Second argument must be a one-dimensional cell array.')
end

if mod(length(constraints), 2)
    error('Number of elements in second argument must be even.')
end

if nargin<4
    id = zeros(length(constraints)/2,1);
    j = 1;
    for i=1:2:length(constraints)
        if isempty(regexp(constraints{i}, 'G\(\w+\)')) i
            tmp = find(strcmp(constraints{i}, DynareModel.endo_names));
        else
            tmp = find(strcmp(constraints{i}(3:end-1), DynareModel.endo_names));
            if ~isempty(tmp)
                tmp = tmp+DynareModel.endo_nbr;
            end
        end
            if isempty(tmp)
                error('Unknown variable (%s).', constraints{i})
            else
                id(j) = tmp;
        end
        j = j+1;
    end
end

Variables = NaN(2*DynareModel.endo_nbr, 1);

jj = 1:length(Variables);
ll = setdiff(jj, id);

Variables(ll) = variables;

values = NaN(length(constraints)/2, 1);

j = 1;
for i=2:2:length(constraints)
    values(j) = constraints{i};
    j = j+1;
end

Variables(id) = values;