function [variables, id] = out(DynareModel, constraints, variables)

if ~iscell(constraints)
    error('Second argument must be a one-dimensional cell array.')
end

if mod(length(constraints), 2)
    error('Number of elements in second argument must be even.')
end

id = zeros(length(constraints)/2,1);

j = 1;

for i=1:2:length(constraints)
    if isempty(regexp(constraints{i}, 'G\(\w+\)'))
        tmp = find(strcmp(constraints{i}, DynareModel.endo_names));
    else
        tmp = find(strcmp(constraints{i}(3:end-1), DynareModel.endo_names));
        if ~isempty(tmp)
            tmp = tmp+DynareModel.endo_nbr;
        end
    end
    assert(~isempty(tmp), 'Unknown variable (%s).', constraints{i})
    id(j) = tmp;
    j = j+1;
end

variables(id) = [];