var y i pi ;

parameters a1 a2 a3 a4 a5;

a1 = -.5;
a2 =  .1;
a3 =  .9;
a4 = 1.5;
a5 = 0.5;

model;

y = y(1)*(i/pi(1))^a1;

pi = (y^a2)*(pi(1)^a3);

i = (pi^a4)*(y^a5);

end;


verbatim;

  bgp.write(M_);

  MC = 1000;

  maxabsdiff = 0;

  for i=1:MC
    y = 1+(rand(3,1)-.5)*.5;
    G = 1+(rand(3,1)-.5)*.1;
    jacobian = fjaco(@checkjacobian.bgpfun, [y;G]);
    [Residuals, Jacobian] = checkjacobian.bgpfun([y;G]);
    maxabsdiff = max(0, max(abs(jacobian(:)-Jacobian(:))));
  end

  assert(maxabsdiff<1e-6, 'Analytical jacobian is wrong.')

end;
