var c k x;

parameters alpha gam delta beta ;

alpha=0.5;
gam=0.5;
delta=0.02;
beta=0.05;

model;
x = x(-1)*1.02;
c + k - x^(1-alpha)*k(-1)^alpha - (1-delta)*k(-1);
c^(-gam) - (1+beta)^(-1)*(alpha*x(+1)^(1-alpha)*k^(alpha-1) + 1 - delta)*c(+1)^(-gam);
end;

verbatim;

  HardCodedLevels = {'k', 10};

  bgp.write(M_, HardCodedLevels{:});

  if isoctave
    options = optimset('Display', 'iter', 'MaxFunEvals', 1000000,'MaxIter',100000,'Jacobian','on','TolFun',1e-7,'TolX',1e-7);
  elseif matlab_ver_less_than('9.0')
    % See https://fr.mathworks.com/help/optim/ug/current-and-legacy-option-name-tables.html
    options = optimoptions('fsolve','Display','iter','Algorithm','levenberg-marquardt','MaxFunEvals',1000000,'MaxIter',100000,'Jacobian','on','TolFun',1e-6,'TolX',1e-6);
  else
    options = optimoptions('fsolve','Display','iter','Algorithm','levenberg-marquardt','MaxFunctionEvaluations',1000000,'MaxIterations',100000,'SpecifyObjectiveGradient',true,'FunctionTolerance',1e-6,'StepTolerance',1e-6);
  end
  y = 1+(rand(M_.endo_nbr,1)-.5)*.25;
  G = 1+0.05*rand(M_.endo_nbr,1);
  y = [y;G];
  [y, id] = bgp.hdl.out(M_, HardCodedLevels, y);
  [y, fval, exitflag] = fsolve(@ramsey.bgpfunhardcon, y, options);
  y = bgp.hdl.in(M_, HardCodedLevels, y, id);
  if ~isoctave
    % Disable under Octave for the time being, it converges to a solution different
    % from the one expected.
    assert(max(abs(y(M_.endo_nbr+(1:M_.orig_endo_nbr))-1.02))<1e-6)
  end

end;
